Search.setIndex({"docnames": ["api", "api/attributes", "api/cache", "api/collections", "api/interfaces", "api/pickling", "changes", "glossary", "index", "using"], "filenames": ["api.rst", "api/attributes.rst", "api/cache.rst", "api/collections.rst", "api/interfaces.rst", "api/pickling.rst", "changes.rst", "glossary.rst", "index.rst", "using.rst"], "titles": ["<code class=\"xref py py-mod docutils literal notranslate\"><span class=\"pre\">persistent</span></code> API documentation", "Customizing Attribute Access", "Caching Persistent Objects", "Persistent Collections", "<code class=\"xref py py-mod docutils literal notranslate\"><span class=\"pre\">persistent.interfaces</span></code>", "Pickling Persistent Objects", "<code class=\"docutils literal notranslate\"><span class=\"pre\">persistent</span></code> Changelog", "Glossary", "<code class=\"xref py py-mod docutils literal notranslate\"><span class=\"pre\">persistent</span></code>:  automatic persistence for Python objects", "Using <code class=\"xref py py-mod docutils literal notranslate\"><span class=\"pre\">persistent</span></code> in your application"], "terms": {"interfac": [0, 2, 6, 8, 9], "ipersist": [0, 4, 9], "ipersistentdatamanag": [0, 4, 9], "ipicklecach": [0, 4, 6], "implement": [0, 1, 2, 6, 8], "collect": [0, 4, 6, 8], "persistentmap": [0, 3, 6, 9], "persistentlist": [0, 3, 6, 9], "custom": [0, 4, 5, 8, 9], "attribut": [0, 3, 4, 5, 6, 7, 8], "access": [0, 2, 4, 7, 8, 9], "hook": 0, "__getattr__": [0, 9], "all": [0, 3, 4, 6, 9], "pickl": [0, 4, 6, 7, 8], "object": [0, 1, 3, 4, 6, 7], "cach": [0, 1, 4, 6, 7, 8], "creat": [0, 1, 3, 4, 6, 9], "de": 0, "novo": 0, "The": [1, 2, 3, 4, 5, 6, 7, 8], "method": [1, 2, 3, 4, 6, 9], "work": [1, 5, 6, 9], "pretti": 1, "much": [1, 6], "same": [1, 6, 7, 9], "persist": [1, 7], "class": [1, 2, 3, 4, 5, 6, 9], "doe": [1, 4, 6], "other": [1, 3, 4, 6, 9], "No": [1, 3], "special": [1, 3, 4, 6, 9], "handl": [1, 4, 6, 9], "i": [1, 2, 3, 4, 6, 7, 9], "need": [1, 6, 9], "If": [1, 3, 4, 6, 9], "an": [1, 2, 3, 4, 6, 7, 8], "ghost": [1, 2, 4, 6, 7, 9], "activ": [1, 4, 6, 7, 9], "befor": [1, 3, 4, 6, 9], "call": [1, 2, 4, 6, 7, 9], "In": [1, 3, 4, 6], "thi": [1, 3, 4, 5, 6, 7, 8, 9], "exampl": [1, 9], "our": [1, 4], "return": [1, 3, 4, 6, 9], "tupl": [1, 4], "name": [1, 3, 4, 6, 7, 9], "convert": 1, "upper": 1, "case": [1, 3, 6, 9], "valu": [1, 3, 4, 5, 6, 9], "_p_chang": [1, 2, 4, 9], "ani": [1, 3, 4, 5, 6, 7, 9], "isn": [1, 9], "t": [1, 2, 4, 5, 6, 9], "default": [1, 3, 4, 6, 9], "machineri": [1, 5, 9], "from": [1, 2, 3, 4, 5, 6, 7, 8], "test": [1, 2, 4, 5], "attrhook": 1, "import": [1, 2, 5, 6, 9], "overridesgetattr": 1, "o": [1, 4], "fals": [1, 4, 6, 9], "_p_oid": [1, 2, 4, 6, 9], "_p_jar": [1, 2, 4, 6, 9], "spam": [1, 5], "1": [1, 2, 5, 8, 9], "we": [1, 4, 5, 9], "ll": 1, "save": [1, 4, 9], "so": [1, 2, 3, 9], "can": [1, 2, 4, 6, 9], "deactiv": [1, 4, 7, 9], "_resettingjar": 1, "jar": [1, 2, 6, 7, 9], "add": [1, 2, 3, 4, 6], "_p_deactiv": [1, 2, 4, 9], "And": 1, "now": [1, 3, 6], "ask": [1, 9], "doesn": [1, 2, 4, 6, 9], "have": [1, 2, 4, 5, 6, 9], "egg": 1, "see": [1, 4, 6], "wa": [1, 3, 4, 6, 9], "provid": [1, 2, 3, 4, 6, 9], "show": 1, "how": [1, 4, 9], "overrid": [1, 2, 4, 5, 6, 8], "store": [1, 6, 7, 9], "": [1, 2, 3, 4, 5, 6, 7, 9], "secret": 1, "dictionari": [1, 3, 6], "within": 1, "instanc": [1, 3, 6, 9], "polici": [1, 4], "variabl": [1, 6], "start": 1, "tmp_": 1, "volatil": [1, 5, 7, 9], "sampl": 1, "take": 1, "initi": [1, 2, 6, 9], "keyword": [1, 3, 6], "argument": [1, 3, 4, 6], "constructor": 1, "verypriv": 1, "x": [1, 3, 5, 9], "It": [1, 4, 5, 6, 8], "support": [1, 5, 6], "inherit": [1, 8], "y": [1, 5], "traceback": [1, 9], "most": [1, 6, 9], "recent": [1, 9], "last": [1, 3, 4, 9], "attributeerror": [1, 6], "next": [1, 6], "databas": [1, 4, 8, 9], "_rememberingjar": 1, "get": [1, 3, 4, 6, 9], "some": [1, 4, 6, 9], "data": [1, 2, 3, 4, 6, 7, 8], "which": [1, 4, 5, 6, 7, 9], "miss": [1, 9], "too": [1, 6], "assign": [1, 2, 4, 5, 6, 9], "implementor": 1, "must": [1, 4, 9], "_p_setattr": [1, 4, 9], "first": [1, 3, 4, 9], "allow": [1, 3, 4, 6], "make": [1, 4, 5, 6, 8, 9], "sure": [1, 4], "necessari": [1, 4, 6], "set": [1, 3, 4, 6, 9], "mark": [1, 3, 4, 6, 9], "chang": [1, 3, 4, 7, 9], "becaus": [1, 7, 9], "directli": [1, 2], "don": [1, 4, 6, 9], "kei": [1, 3, 6, 9], "__dict__": [1, 5, 6, 9], "give": 1, "rememb": 1, "modifi": [1, 3, 4, 9], "2": [1, 3, 5, 8, 9], "reactiv": 1, "true": [1, 2, 4, 5, 9], "fake": 1, "commit": [1, 4, 6], "fake_commit": 1, "tmp_foo": 1, "3": [1, 4, 5, 8, 9], "delet": [1, 2, 3, 4, 6, 9], "_p_delattr": [1, 4, 6, 9], "tmp_z": 1, "del": [1, 3, 9], "also": [1, 3, 4, 6, 7, 9], "attempt": [1, 6, 9], "find": 1, "valueerror": [1, 3, 4, 6, 9], "ar": [1, 2, 3, 4, 5, 6, 7, 9], "none": [1, 2, 3, 4, 6, 9], "scratch": 2, "oppos": 2, "ghostifi": [2, 4, 6], "non": [2, 4, 6, 9], "rather": 2, "tricki": 2, "iperist": 2, "realli": [2, 6], "right": 2, "given": [2, 3, 4, 7], "_p_invalid": [2, 4, 9], "could": [2, 4, 6], "assum": [2, 9], "state": [2, 4, 5, 6, 7, 9], "properli": [2, 6], "just": 2, "current": [2, 4, 9], "intim": 2, "ti": 2, "up": [2, 4], "ha": [2, 4, 6, 7, 9], "intern": [2, 6, 9], "updat": [2, 3, 4, 6], "newli": [2, 6], "uniniti": 2, "futur": 2, "far": 2, "more": [2, 6], "decoupl": 2, "onli": [2, 3, 4, 6], "manag": [2, 4, 7, 8], "gener": [2, 6, 8], "usag": [2, 6], "event": [2, 6], "respons": [2, 7, 9], "relat": 2, "meta": [2, 4], "_p_state": [2, 4, 8], "etc": [2, 9], "central": 2, "inform": 2, "new_ghost": [2, 4, 6], "its": [2, 4, 6, 7, 8], "util": [2, 6], "resettingjar": 2, "c": [2, 4, 5, 6], "pass": [2, 4, 6, 9], "picklecach": [2, 6], "10": [2, 8], "100": [2, 6], "ob": [2, 9], "__new__": [2, 6], "b": [2, 3, 6, 9], "cache_non_ghost_count": [2, 4], "0": [2, 4, 5, 8, 9], "packag": [3, 4, 6, 8], "two": [3, 4, 6], "simpl": [3, 5], "keep": [3, 4, 9], "track": [3, 9], "when": [3, 4, 6, 9], "thei": [3, 4, 6, 9], "mutat": [3, 7, 9], "place": 3, "map": [3, 5], "dict": [3, 4, 6, 9], "kwarg": 3, "sourc": [3, 4, 6], "base": [3, 4, 5, 9], "userdict": [3, 6], "A": [3, 4, 6, 9], "wrapper": 3, "wrap": 3, "regist": [3, 4, 6, 9], "As": 3, "side": [3, 9], "effect": [3, 6, 9], "mai": [3, 4, 6], "subclass": [3, 4, 6, 9], "code": [3, 4, 6], "new": [3, 6], "should": [3, 4, 6], "_contain": 3, "reserv": [3, 4], "backward": [3, 9], "compat": [3, 6, 9], "reason": [3, 4, 9], "clear": [3, 6], "remov": [3, 4, 6, 9], "version": [3, 6, 9], "4": [3, 8], "5": [3, 8, 9], "noth": 3, "longer": [3, 6], "pop": [3, 6], "k": 3, "d": [3, 5], "v": 3, "specifi": 3, "correspond": [3, 4], "found": [3, 4], "otherwis": [3, 4], "keyerror": [3, 4, 6], "rais": [3, 4, 6, 9], "popitem": [3, 6], "item": [3, 4, 6], "empti": [3, 4, 6], "except": [3, 4, 6, 9], "setdefault": [3, 6], "e": [3, 4, 9], "f": [3, 5], "accept": [3, 6], "arbitrari": 3, "behaviour": [3, 6], "list": [3, 9], "initlist": 3, "userlist": 3, "caus": [3, 4, 7, 9], "them": [3, 6], "automat": [3, 6, 9], "us": [3, 4, 6, 8], "slice": [3, 6], "g": [3, 4, 9], "inst": 3, "result": [3, 4, 6], "actual": 3, "append": 3, "end": [3, 4], "sequenc": [3, 4], "extend": [3, 4], "iter": [3, 4], "element": 3, "insert": 3, "index": [3, 8], "indexerror": 3, "out": [3, 6, 9], "rang": 3, "occurr": 3, "present": 3, "revers": 3, "IN": 3, "python": [4, 5, 6, 7, 9], "one": [4, 9], "sever": 4, "unsav": 4, "been": [4, 6, 7, 9], "sinc": [4, 9], "sticki": 4, "ident": 4, "cannot": [4, 6], "transit": 4, "unload": 4, "middl": 4, "comput": 4, "There": 4, "api": [4, 8], "detect": [4, 6], "whether": [4, 6], "memori": [4, 6], "load": [4, 5, 6, 7, 9], "contain": [4, 6, 8, 9], "applic": [4, 8], "obtain": 4, "abov": 4, "id": [4, 7, 9], "follow": 4, "possibl": [4, 6], "occur": [4, 6], "usual": 4, "happen": [4, 6], "ad": [4, 6], "transact": [4, 6, 9], "someon": 4, "requir": [4, 6, 9], "itself": [4, 6], "prior": [4, 6], "zodb": [4, 6, 8, 9], "6": [4, 8], "ignor": [4, 5], "remain": [4, 7, 9], "continu": [4, 6], "prevent": [4, 6], "invalid": [4, 6, 7, 9], "discuss": 4, "below": [4, 9], "unmark": 4, "after": [4, 5, 6, 9], "dure": [4, 6, 7], "abort": [4, 6], "oper": [4, 6], "note": [4, 5, 6, 9], "separ": 4, "includ": [4, 6, 9], "here": 4, "specif": [4, 6], "layout": [4, 6], "defin": [4, 5, 9], "about": [4, 6], "intend": 4, "short": [4, 7], "live": 4, "being": [4, 6, 9], "discard": [4, 7], "while": [4, 6], "re": [4, 6], "routin": 4, "error": [4, 6], "request": [4, 6, 9], "becom": 4, "optim": [4, 6], "equival": 4, "wai": [4, 6, 9], "prefer": 4, "semant": 4, "normal": [4, 5, 9], "howev": 4, "immedi": [4, 9], "reload": [4, 9], "repr": [4, 6, 9], "By": 4, "option": 4, "_p_repr": [4, 6, 8], "instead": [4, 6, 9], "caught": 4, "constraint": [4, 9], "enforc": 4, "onc": [4, 9], "anoth": 4, "indic": 4, "string": [4, 6], "8": [4, 8], "byte": [4, 6], "consist": [4, 6], "nul": 4, "identifi": [4, 7], "root": 4, "oid": [4, 6], "never": [4, 6], "even": [4, 5, 9], "At": 4, "forc": [4, 9], "independ": 4, "exist": 4, "although": 4, "_p_serial": [4, 9], "serial": [4, 7], "number": 4, "member": 4, "distiguish": 4, "distinct": 4, "revis": 4, "unicod": 4, "_p_mtime": 4, "modif": [4, 9], "time": [4, 6, 9], "read": 4, "float": [4, 6], "repres": [4, 9], "second": [4, 6], "epoch": 4, "token": 4, "uptod": [4, 7, 9], "_p_estimated_s": [4, 6, 9], "estim": [4, 8], "size": [4, 6, 8], "__getattribute__": [4, 9], "_p_": [4, 5, 9], "__setattr__": [4, 6, 9], "__delattr__": [4, 6, 9], "__getstate__": [4, 5, 9], "_p_name": 4, "picklabl": 4, "__setstate__": [4, 5, 6, 9], "__reduce__": [4, 5], "reduc": [4, 6, 9], "contitu": 4, "part": [4, 7], "_p_activ": [4, 6, 9], "possibli": [4, 6], "choos": 4, "thrown": 4, "awai": 4, "move": [4, 6, 7, 9], "further": 4, "_p_getattr": [4, 9], "unghostifi": 4, "record": 4, "do": [4, 5, 6, 9], "anyth": 4, "els": 4, "deleg": [4, 9], "servic": 4, "interact": [4, 8, 9], "context": 4, "_cach": [4, 9], "associ": [4, 7, 8], "connect": [4, 6, 9], "setstat": [4, 6, 9], "oldstat": 4, "obj": 4, "tid": 4, "copi": [4, 6], "written": 4, "typic": [4, 6], "metadata": 4, "m": 4, "refer": [4, 6, 7, 9], "perist": 4, "paramet": [4, 6], "wrote": 4, "earlier": [4, 9], "each": [4, 9], "thread": 4, "__getitem__": 4, "__setitem__": 4, "under": [4, 6], "duplic": 4, "__delitem__": 4, "__len__": 4, "p": [4, 9], "ringlen": 4, "ring": 4, "lru_item": 4, "lru": 4, "order": [4, 6, 9], "klass_item": 4, "incrgc": [4, 6], "perform": 4, "increment": 4, "garbag": [4, 6], "sweep": [4, 6], "cache_s": [4, 6], "skip": 4, "dirti": 4, "quit": 4, "down": 4, "full_sweep": [4, 6], "full": 4, "objec": 4, "minim": [4, 6], "alia": [4, 6, 7], "xxx": 4, "ensur": [4, 6, 9], "alreadi": 4, "to_invalid": 4, "treat": 4, "over": 4, "For": [4, 9], "corrspond": 4, "debug_info": 4, "debug": 4, "refcount": 4, "typenam": 4, "update_object_size_estim": 4, "new_siz": 4, "known": 4, "target": 4, "cache_drain_resist": 4, "factor": 4, "drain": 4, "differ": [4, 7, 9], "cache_data": 4, "properti": [4, 6], "cache_klass_count": 4, "len": 4, "persistent_class": 4, "design": 5, "standard": 5, "happi": 5, "cucumb": 5, "print_dict": 5, "aaa": 5, "bbb": 5, "foo": 5, "__name__": 5, "__newobj__": 5, "__module__": 5, "replac": [5, 6, 9], "_": 5, "python2": 5, "copyreg": 5, "dump": 5, "z": 5, "well": [5, 9], "deriv": [5, 9], "__getnewargs__": 5, "99": 5, "ax": 5, "ai": 5, "__slots__": [5, 6], "slot": [5, 6], "onto": 5, "namespac": 5, "prefix": [5, 9], "_v_": 5, "subslot": 5, "haven": 5, "yet": [5, 6, 7, 9], "s4": 5, "s1": 5, "s2": 5, "s3": 5, "__slot": 5, "attr": 5, "themselv": [5, 9], "subsubslot": 5, "bar": 5, "baz": 5, "bam": 5, "preliminari": 6, "12a6": 6, "build": 6, "linux": 6, "binari": 6, "wheel": 6, "drop": 6, "arm64": 6, "maco": 6, "final": 6, "releas": 6, "rc1": 6, "disabl": 6, "unsaf": 6, "math": 6, "pull": 6, "176": 6, "11a5": 6, "switch": 6, "src": 6, "168": 6, "travi": 6, "ci": 6, "github": 6, "action": 6, "suppli": 6, "manylinux": 6, "aarch64": 6, "arm": 6, "fix": 6, "pure": 6, "__class__": [6, 9], "match": 6, "issu": 6, "155": 6, "cffi": 6, "cpython": 6, "pure_python": 6, "print": [6, 9], "unrais": 6, "_weakvaluedictionari": 6, "150": 6, "run": 6, "gc": 6, "weakli": 6, "referenc": 6, "eject": 6, "solv": 6, "pypi": 6, "connectionstateerror": 6, "zope": [6, 9], "adapt": 6, "partli": 6, "revert": 6, "overli": 6, "failur": 6, "144": 6, "leak": 6, "theoret": 6, "obscur": 6, "143": 6, "crash": 6, "suit": 6, "32": 6, "bit": [6, 9], "certain": 6, "137": 6, "jerri": 6, "jame": 6, "assertionerror": 6, "139": 6, "stop": 6, "instal": 6, "header": 6, "file": 6, "what": [6, 9], "135": 6, "alwai": [6, 9], "broken": 6, "underli": 6, "environ": 6, "extens": 6, "togeth": 6, "strang": 6, "aris": 6, "mismatch": 6, "131": 6, "privat": 6, "detail": 6, "pr": 6, "115": 6, "like": [6, 9], "nativ": 6, "previous": 6, "typeerror": 6, "undocu": 6, "extrem": 6, "unlik": [6, 7, 9], "singl": 6, "adjust": [6, 9], "signatur": 6, "9a3": 6, "124": 6, "abl": 6, "133": 6, "ctype": 6, "fulli": 6, "discrep": 6, "between": [6, 9], "type": 6, "bad": 6, "input": 6, "word": 6, "messag": 6, "uniqu": [6, 7, 9], "were": 6, "iextendedpicklecach": 6, "p_jar": 6, "102": 6, "without": [6, 8], "cache_size_byt": 6, "larg": 6, "jython": 6, "untest": 6, "77": 6, "deprecationwarn": 6, "py_ssize_t_clean": 6, "108": 6, "modul": [6, 8], "92": 6, "format": 6, "integ": [6, 9], "hexadecim": 6, "notat": 6, "elimin": 6, "doctest": 6, "95": 6, "explicitli": [6, 8], "unsign": 6, "constant": [6, 9], "pack": 6, "unpack": 6, "timestamp": 6, "arithmet": 6, "gcc": 6, "enabl": 6, "fwrapv": 6, "86": 6, "88": 6, "avoid": 6, "overflow": 6, "compil": 6, "represent": [6, 9], "abil": 6, "__repr__": [6, 9], "better": 6, "reach": 6, "maintain": [6, 9], "coverag": 6, "simplifi": 6, "__init__": [6, 9], "py": 6, "legaci": 6, "80": 6, "avail": 6, "deprec": 6, "distribut": 6, "function": 6, "75": 6, "_p": 6, "correctli": 6, "shim": 6, "82": 6, "across": [6, 7], "point": [6, 9], "trip": 6, "through": 6, "raw": 6, "erron": 6, "round": 6, "precis": 6, "41": 6, "rare": 6, "dealloc": 6, "http": 6, "com": 6, "zopefound": 6, "66": 6, "cpicklecach": 6, "comparison": 6, "determin": 6, "go": 6, "pyobject_typecheck": 6, "stronger": 6, "potenti": 6, "cpersistent_head": 6, "tp_base": 6, "cpersistencecapi": 6, "pertyp": 6, "still": [6, 9], "elig": 6, "69": 6, "built": 6, "systemerror": 6, "whose": [6, 7, 9], "poskeyerror": 6, "hashcod": 6, "64": 6, "window": 6, "55": 6, "everi": 6, "boundari": 6, "mode": 6, "mean": 6, "report": 6, "wrong": 6, "until": [6, 9], "faster": 6, "observ": 6, "user": 6, "maximum": 6, "increas": 6, "31": 6, "exclus": 6, "wiki": 6, "notes_on_state_new_and_slot": 6, "you": [6, 9], "curiou": 6, "timetim": 6, "subsecond": 6, "tox": 6, "poison": 6, "global": 6, "manifest": 6, "upload": 6, "strai": 6, "behav": [6, 9], "similarli": 6, "particular": [6, 7], "complet": 6, "zeo": 6, "alik": 6, "produc": 6, "output": 6, "addit": [6, 9], "equal": 6, "unpickl": [6, 9], "multipl": 6, "pypy3": 6, "branch": 6, "corrupt": 6, "throw": 6, "creation": [6, 9], "_p_access": 6, "exactli": [6, 9], "hang": 6, "manual": [6, 9], "trove": 6, "classifi": 6, "py3k": 6, "extenst": 6, "impliment": 6, "compar": 6, "pointer": 6, "undefin": 6, "warn": 6, "propeti": 6, "didn": 6, "incorrect": 6, "correct": 6, "renam": 6, "_timestamp": 6, "around": 6, "due": 6, "long": 6, "system": 6, "clash": 6, "insensit": 6, "filesystem": 6, "n": 6, "canon": 6, "yield": 6, "fall": 6, "back": [6, 7, 9], "explicit": 6, "unit": 6, "depend": 6, "rewrot": 6, "clone": 6, "remaind": 6, "refactor": 6, "unittest": 6, "cover": 6, "integr": 6, "jenkin": 6, "setup": 6, "dev": 6, "nose": 6, "testrunn": 6, "mani": 6, "sphinx": 6, "snippet": 6, "exercis": 6, "via": 6, "doc": 6, "repoz": 6, "autointerfac": 6, "either": [7, 9], "tradition": 7, "hold": 7, "mru": 7, "stabl": 7, "analog": 7, "process": 7, "retriev": 7, "captur": 7, "These": 7, "thu": 7, "disappear": 7, "form": 8, "core": 8, "protocol": 8, "transpar": 8, "content": 8, "your": 8, "relationship": 8, "control": 8, "document": 8, "changelog": 8, "unreleas": 8, "2023": 8, "01": 8, "09": 8, "9": 8, "2022": 8, "11": 8, "16": 8, "03": 8, "07": 8, "7": 8, "2021": 8, "04": 8, "13": 8, "2020": 8, "26": 8, "18": 8, "12": 8, "06": 8, "05": 8, "2019": 8, "2018": 8, "22": 8, "08": 8, "28": 8, "23": 8, "30": 8, "2017": 8, "21": 8, "20": 8, "2016": 8, "29": 8, "2015": 8, "02": 8, "19": 8, "2014": 8, "2013": 8, "2012": 8, "14": 8, "27": 8, "glossari": 8, "search": 8, "page": 8, "basic": 9, "mechan": 9, "mix": 9, "capabl": 9, "notifi": 9, "sort": 9, "subsequ": 9, "least": 9, "stub": 9, "dm": 9, "def": 9, "self": 9, "42": 9, "notic": 9, "inc": 9, "extra": 9, "three": 9, "flag": 9, "lifecycl": 9, "try": 9, "behavior": 9, "00000012": 9, "candid": 9, "storag": 9, "later": 9, "describ": 9, "expos": 9, "rest": 9, "put": 9, "43": 9, "op": 9, "reset": 9, "field": 9, "retain": 9, "coercibl": 9, "leav": 9, "those": 9, "begin": 9, "_v__": 9, "_v_foo": 9, "affect": 9, "Its": 9, "help": 9, "strategi": 9, "bound": 9, "1000": 9, "1024": 9, "huh": 9, "why": 9, "come": 9, "than": 9, "fit": 9, "24": 9, "somewhat": 9, "Of": 9, "cours": 9, "neg": 9, "obei": 9, "regular": 9, "benefit": 9, "safer": 9, "close": 9}, "objects": {"persistent": [[4, 0, 1, "", "Persistent"], [4, 1, 0, "-", "interfaces"]], "persistent.interfaces": [[4, 2, 1, "", "IPersistent"], [4, 2, 1, "", "IPersistentDataManager"], [4, 2, 1, "", "IPickleCache"]], "persistent.interfaces.IPersistent": [[4, 3, 1, "", "__delattr__"], [4, 3, 1, "", "__getattribute__"], [4, 3, 1, "", "__getstate__"], [4, 3, 1, "", "__reduce__"], [4, 3, 1, "", "__setattr__"], [4, 3, 1, "", "__setstate__"], [4, 3, 1, "", "_p_activate"], [4, 4, 1, "", "_p_changed"], [4, 3, 1, "", "_p_deactivate"], [4, 3, 1, "", "_p_delattr"], [4, 4, 1, "", "_p_estimated_size"], [4, 3, 1, "", "_p_getattr"], [4, 3, 1, "", "_p_invalidate"], [4, 4, 1, "", "_p_jar"], [4, 4, 1, "", "_p_mtime"], [4, 4, 1, "", "_p_oid"], [4, 4, 1, "", "_p_serial"], [4, 3, 1, "", "_p_setattr"], [4, 4, 1, "", "_p_state"]], "persistent.interfaces.IPersistentDataManager": [[4, 4, 1, "", "_cache"], [4, 3, 1, "", "oldstate"], [4, 3, 1, "", "register"], [4, 3, 1, "", "setstate"]], "persistent.interfaces.IPickleCache": [[4, 3, 1, "", "__delitem__"], [4, 3, 1, "", "__getitem__"], [4, 3, 1, "", "__len__"], [4, 3, 1, "", "__setitem__"], [4, 4, 1, "", "cache_data"], [4, 4, 1, "", "cache_drain_resistance"], [4, 4, 1, "", "cache_klass_count"], [4, 4, 1, "", "cache_non_ghost_count"], [4, 4, 1, "", "cache_size"], [4, 3, 1, "", "debug_info"], [4, 3, 1, "", "full_sweep"], [4, 3, 1, "", "get"], [4, 3, 1, "", "incrgc"], [4, 3, 1, "", "invalidate"], [4, 3, 1, "", "items"], [4, 3, 1, "", "klass_items"], [4, 3, 1, "", "lru_items"], [4, 3, 1, "", "minimize"], [4, 3, 1, "", "new_ghost"], [4, 3, 1, "", "ringlen"], [4, 3, 1, "", "update_object_size_estimation"]], "persistent.list": [[3, 0, 1, "", "PersistentList"]], "persistent.list.PersistentList": [[3, 3, 1, "", "append"], [3, 3, 1, "", "clear"], [3, 3, 1, "", "extend"], [3, 3, 1, "", "insert"], [3, 3, 1, "", "pop"], [3, 3, 1, "", "remove"], [3, 3, 1, "", "reverse"]], "persistent.mapping": [[3, 0, 1, "", "PersistentMapping"]], "persistent.mapping.PersistentMapping": [[3, 3, 1, "", "clear"], [3, 3, 1, "", "pop"], [3, 3, 1, "", "popitem"], [3, 3, 1, "", "setdefault"], [3, 3, 1, "", "update"]]}, "objtypes": {"0": "py:class", "1": "py:module", "2": "py:interface", "3": "py:method", "4": "py:attribute"}, "objnames": {"0": ["py", "class", "Python class"], "1": ["py", "module", "Python module"], "2": ["py", "interface", "Python interface"], "3": ["py", "method", "Python method"], "4": ["py", "attribute", "Python attribute"]}, "titleterms": {"persist": [0, 2, 3, 4, 5, 6, 8, 9], "api": 0, "document": [0, 6], "custom": 1, "attribut": [1, 9], "access": 1, "hook": 1, "__getattr__": 1, "all": 1, "__getattribute__": 1, "__setattr__": 1, "__delattr__": 1, "cach": [2, 9], "object": [2, 5, 8, 9], "creat": 2, "de": 2, "novo": 2, "collect": 3, "interfac": 4, "implement": [4, 9], "pickl": [5, 9], "changelog": 6, "5": 6, "1": 6, "unreleas": 6, "0": 6, "2023": 6, "01": 6, "09": 6, "4": 6, "9": 6, "3": 6, "2022": 6, "11": 6, "16": 6, "2": 6, "03": 6, "10": 6, "8": 6, "07": 6, "7": 6, "2021": 6, "04": 6, "13": 6, "6": 6, "2020": 6, "26": 6, "18": 6, "12": 6, "06": 6, "05": 6, "2019": 6, "2018": 6, "22": 6, "08": 6, "28": 6, "23": 6, "30": 6, "2017": 6, "21": 6, "20": 6, "2016": 6, "29": 6, "2015": 6, "02": 6, "19": 6, "2014": 6, "2013": 6, "2012": 6, "14": 6, "27": 6, "platform": 6, "chang": 6, "test": 6, "glossari": 7, "automat": 8, "python": 8, "indic": 8, "tabl": 8, "us": 9, "your": 9, "applic": 9, "inherit": 9, "from": 9, "relationship": 9, "data": 9, "manag": 9, "its": 9, "without": 9, "associ": 9, "an": 9, "explicitli": 9, "control": 9, "_p_state": 9, "The": 9, "protocol": 9, "estim": 9, "size": 9, "overrid": 9, "_p_repr": 9}, "envversion": {"sphinx.domains.c": 2, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 8, "sphinx.domains.index": 1, "sphinx.domains.javascript": 2, "sphinx.domains.math": 2, "sphinx.domains.python": 3, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx.ext.intersphinx": 1, "sphinx.ext.todo": 2, "sphinx.ext.viewcode": 1, "sphinx": 57}, "alltitles": {"persistent API documentation": [[0, "persistent-api-documentation"]], "Customizing Attribute Access": [[1, "customizing-attribute-access"]], "Hooking __getattr__()": [[1, "hooking-getattr"]], "Hooking All Access": [[1, "hooking-all-access"]], "Hooking __getattribute__`()": [[1, "hooking-getattribute"]], "Hooking __setattr__`()": [[1, "hooking-setattr"]], "Hooking __delattr__`()": [[1, "hooking-delattr"]], "Caching Persistent Objects": [[2, "caching-persistent-objects"]], "Creating Objects de novo": [[2, "creating-objects-de-novo"]], "Persistent Collections": [[3, "persistent-collections"]], "persistent.interfaces": [[4, "module-persistent.interfaces"]], "Implementations": [[4, "implementations"]], "Pickling Persistent Objects": [[5, "pickling-persistent-objects"]], "persistent Changelog": [[6, "persistent-changelog"]], "5.1 (unreleased)": [[6, "unreleased"]], "5.0 (2023-01-09)": [[6, "id1"]], "4.9.3 (2022-11-16)": [[6, "id2"]], "4.9.2 (2022-11-03)": [[6, "id3"]], "4.9.1 (2022-09-16)": [[6, "id4"]], "4.9.0 (2022-03-10)": [[6, "id5"]], "4.8.0 (2022-03-07)": [[6, "id6"]], "4.7.0 (2021-04-13)": [[6, "id8"]], "4.6.4 (2020-03-26)": [[6, "id9"]], "4.6.3 (2020-03-18)": [[6, "id10"]], "4.6.2 (2020-03-12)": [[6, "id11"]], "4.6.1 (2020-03-06)": [[6, "id12"]], "4.6.0 (2020-03-05)": [[6, "id13"]], "4.5.1 (2019-11-06)": [[6, "id14"]], "4.5.0 (2019-05-09)": [[6, "id15"]], "4.4.3 (2018-10-22)": [[6, "id16"]], "4.4.2 (2018-08-28)": [[6, "id17"]], "4.4.1 (2018-08-23)": [[6, "id18"]], "4.4.0 (2018-08-22)": [[6, "id19"]], "4.3.0 (2018-07-30)": [[6, "id21"]], "4.2.4.2 (2017-04-23)": [[6, "id22"]], "4.2.4.1 (2017-04-21)": [[6, "id23"]], "4.2.4 (2017-03-20)": [[6, "id24"]], "4.2.3 (2017-03-08)": [[6, "id25"]], "4.2.2 (2016-11-29)": [[6, "id26"]], "4.2.1 (2016-05-26)": [[6, "id27"]], "4.2.0 (2016-05-05)": [[6, "id28"]], "4.1.1 (2015-06-02)": [[6, "id29"]], "4.1.0 (2015-05-19)": [[6, "id30"]], "4.0.9 (2015-04-08)": [[6, "id31"]], "4.0.8 (2014-03-20)": [[6, "id32"]], "4.0.7 (2014-02-20)": [[6, "id33"]], "4.0.6 (2013-01-03)": [[6, "id34"]], "4.0.5 (2012-12-14)": [[6, "id35"]], "4.0.4 (2012-12-11)": [[6, "id36"]], "4.0.3 (2012-11-19)": [[6, "id37"]], "4.0.2 (2012-08-27)": [[6, "id38"]], "4.0.1 (2012-08-26)": [[6, "id39"]], "4.0.0 (2012-08-11)": [[6, "id40"]], "Platform Changes": [[6, "platform-changes"]], "Testing Changes": [[6, "testing-changes"]], "Documentation Changes": [[6, "documentation-changes"]], "Glossary": [[7, "glossary"]], "persistent:  automatic persistence for Python objects": [[8, "persistent-automatic-persistence-for-python-objects"]], "Indices and tables": [[8, "indices-and-tables"]], "Using persistent in your application": [[9, "using-persistent-in-your-application"]], "Inheriting from persistent.Persistent": [[9, "inheriting-from-persistent-persistent"]], "Relationship to a Data Manager and its Cache": [[9, "relationship-to-a-data-manager-and-its-cache"]], "Persistent objects without a Data Manager": [[9, "persistent-objects-without-a-data-manager"]], "Associating an Object with a Data Manager": [[9, "associating-an-object-with-a-data-manager"]], "Explicitly controlling _p_state": [[9, "explicitly-controlling-p-state"]], "The pickling protocol": [[9, "the-pickling-protocol"]], "Estimated Object Size": [[9, "estimated-object-size"]], "Overriding the attribute protocol": [[9, "overriding-the-attribute-protocol"]], "Implementing _p_repr": [[9, "implementing-p-repr"]]}, "indexentries": {"persistentlist (class in persistent.list)": [[3, "persistent.list.PersistentList"]], "persistentmapping (class in persistent.mapping)": [[3, "persistent.mapping.PersistentMapping"]], "append() (persistent.list.persistentlist method)": [[3, "persistent.list.PersistentList.append"]], "clear() (persistent.list.persistentlist method)": [[3, "persistent.list.PersistentList.clear"]], "clear() (persistent.mapping.persistentmapping method)": [[3, "persistent.mapping.PersistentMapping.clear"]], "extend() (persistent.list.persistentlist method)": [[3, "persistent.list.PersistentList.extend"]], "insert() (persistent.list.persistentlist method)": [[3, "persistent.list.PersistentList.insert"]], "pop() (persistent.list.persistentlist method)": [[3, "persistent.list.PersistentList.pop"]], "pop() (persistent.mapping.persistentmapping method)": [[3, "persistent.mapping.PersistentMapping.pop"]], "popitem() (persistent.mapping.persistentmapping method)": [[3, "persistent.mapping.PersistentMapping.popitem"]], "remove() (persistent.list.persistentlist method)": [[3, "persistent.list.PersistentList.remove"]], "reverse() (persistent.list.persistentlist method)": [[3, "persistent.list.PersistentList.reverse"]], "setdefault() (persistent.mapping.persistentmapping method)": [[3, "persistent.mapping.PersistentMapping.setdefault"]], "update() (persistent.mapping.persistentmapping method)": [[3, "persistent.mapping.PersistentMapping.update"]], "ipersistent (interface in persistent.interfaces)": [[4, "persistent.interfaces.IPersistent"]], "ipersistentdatamanager (interface in persistent.interfaces)": [[4, "persistent.interfaces.IPersistentDataManager"]], "ipicklecache (interface in persistent.interfaces)": [[4, "persistent.interfaces.IPickleCache"]], "persistent (class in persistent)": [[4, "persistent.Persistent"]], "__delattr__() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent.__delattr__"]], "__delitem__() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.__delitem__"]], "__getattribute__() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent.__getattribute__"]], "__getitem__() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.__getitem__"]], "__getstate__() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent.__getstate__"]], "__len__() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.__len__"]], "__reduce__() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent.__reduce__"]], "__setattr__() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent.__setattr__"]], "__setitem__() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.__setitem__"]], "__setstate__() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent.__setstate__"]], "_cache (persistent.interfaces.ipersistentdatamanager attribute)": [[4, "persistent.interfaces.IPersistentDataManager._cache"]], "_p_activate() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent._p_activate"]], "_p_changed (persistent.interfaces.ipersistent attribute)": [[4, "persistent.interfaces.IPersistent._p_changed"]], "_p_deactivate() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent._p_deactivate"]], "_p_delattr() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent._p_delattr"]], "_p_estimated_size (persistent.interfaces.ipersistent attribute)": [[4, "persistent.interfaces.IPersistent._p_estimated_size"]], "_p_getattr() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent._p_getattr"]], "_p_invalidate() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent._p_invalidate"]], "_p_jar (persistent.interfaces.ipersistent attribute)": [[4, "persistent.interfaces.IPersistent._p_jar"]], "_p_mtime (persistent.interfaces.ipersistent attribute)": [[4, "persistent.interfaces.IPersistent._p_mtime"]], "_p_oid (persistent.interfaces.ipersistent attribute)": [[4, "persistent.interfaces.IPersistent._p_oid"]], "_p_serial (persistent.interfaces.ipersistent attribute)": [[4, "persistent.interfaces.IPersistent._p_serial"]], "_p_setattr() (persistent.interfaces.ipersistent method)": [[4, "persistent.interfaces.IPersistent._p_setattr"]], "_p_state (persistent.interfaces.ipersistent attribute)": [[4, "persistent.interfaces.IPersistent._p_state"]], "cache_data (persistent.interfaces.ipicklecache attribute)": [[4, "persistent.interfaces.IPickleCache.cache_data"]], "cache_drain_resistance (persistent.interfaces.ipicklecache attribute)": [[4, "persistent.interfaces.IPickleCache.cache_drain_resistance"]], "cache_klass_count (persistent.interfaces.ipicklecache attribute)": [[4, "persistent.interfaces.IPickleCache.cache_klass_count"]], "cache_non_ghost_count (persistent.interfaces.ipicklecache attribute)": [[4, "persistent.interfaces.IPickleCache.cache_non_ghost_count"]], "cache_size (persistent.interfaces.ipicklecache attribute)": [[4, "persistent.interfaces.IPickleCache.cache_size"]], "debug_info() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.debug_info"]], "full_sweep() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.full_sweep"]], "get() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.get"]], "incrgc() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.incrgc"]], "invalidate() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.invalidate"]], "items() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.items"]], "klass_items() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.klass_items"]], "lru_items() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.lru_items"]], "minimize() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.minimize"]], "module": [[4, "module-persistent.interfaces"]], "new_ghost() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.new_ghost"]], "oldstate() (persistent.interfaces.ipersistentdatamanager method)": [[4, "persistent.interfaces.IPersistentDataManager.oldstate"]], "persistent.interfaces": [[4, "module-persistent.interfaces"]], "register() (persistent.interfaces.ipersistentdatamanager method)": [[4, "persistent.interfaces.IPersistentDataManager.register"]], "ringlen() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.ringlen"]], "setstate() (persistent.interfaces.ipersistentdatamanager method)": [[4, "persistent.interfaces.IPersistentDataManager.setstate"]], "update_object_size_estimation() (persistent.interfaces.ipicklecache method)": [[4, "persistent.interfaces.IPickleCache.update_object_size_estimation"]], "activation": [[7, "term-activation"]], "data manager": [[7, "term-data-manager"]], "deactivation": [[7, "term-deactivation"]], "ghost": [[7, "term-ghost"]], "invalidation": [[7, "term-invalidation"]], "jar": [[7, "term-jar"]], "object cache": [[7, "term-object-cache"]], "object id": [[7, "term-object-id"]], "pickled data": [[7, "term-pickled-data"]], "volatile attribute": [[7, "term-volatile-attribute"]]}})